#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

void smooth(float *fdat,int N,int nsm)
{
    int i,j,mid=(nsm-1)/2;
    float *org,avg,w;

    org = (float *)malloc((N+2*mid)*sizeof(float));
    w = 1./(float)nsm;
    for(i=0;i<mid;i++) 
    {
	org[i] = fdat[i+1];
	org[N+i+mid] = fdat[N-i-2];
    }
    for(i=mid;i<N+mid;i++) org[i] = fdat[i-mid];

    for(i=0;i<N;i++)
    {
	for(j=0,avg=0.;j<=nsm;j++) avg += org[i+j];
	fdat[i] = w*avg;
    }
}
